%*********************************************************
%
%   site.sl
%
%   This file must be present in JED_ROOT/lib. The Editor
%   loads it first, even before reading command line arguments.
%   Indeed, the command line arguments are processed by a hook
%   declared in this file.
%
%   Also utility functions are defined and basic functions
%   initialized.
%
%*********************************************************

   _traceback = 1;

%--- required prototypes ----------------------------------

define is_whiteline ();
define what_block   ();
define shape_cursor1 ();

%----------------------------------------------------------

autoload ("mini_keymap",    "basics");
autoload ("dls",            "dls");
autoload ("dtr",            "dtr");
autoload ("display_help",   "suemenu");
autoload ("suemenu",        "suemenu");

%*********************************************************
%   Global Variables
%*********************************************************

variable _Default_Color_Scheme = "sue_color";
variable DirListing  = " /DirListing/";
variable TreeView   = " /TreeView/";
variable slash = "/";
variable red = Assoc_Type [Integer_Type];
variable r_dir = Assoc_Type [Integer_Type];
%   used for recently edited files and accessed directories
variable bkm = Assoc_Type [Array_Type]; % bookmarks

variable Null_String        = "";
variable LASTDIR            = Null_String;
variable LAST_SAVED         = Null_String;
variable Jed_Home_Directory = Null_String;
variable LAST_SEARCH        = Null_String;
variable o_ListBuffer       = Null_String;
variable f_ListBuffer       = Null_String;
variable WordSet            = Null_String;
variable GreyChars          = Null_String;
variable BlackChars         = Null_String;
variable current_mini_cmd   = Null_String;
variable InsertBuffer       = Null_String;

variable SEARCH_TYPE = 0;
%   0 simple search, 1 regex

variable dbG = 0;
%   for debugging

variable mS = 0;
%   mS indicates one of 3 types of history
%   0   for strings wanted
%   1   for paths and files
%   2   for motley mix

variable globl_str = Null_String;
variable globl_int = 0;
variable viewer_only = 0;

variable c_kmap = "ctrl_kmap";
%   global keymap when <ctrl> is pressed
%   however, crtl-a to ctrl-z are not here
%   as low ascii, they are in the plain global map

variable s_kmap     = "shift_kmap";
variable s_c_kmap   = "shiftctrl_kmap";
variable a_kmap     = "alt_kmap";

%   strings same as in the GNU/Linux console keymap

variable Key_BS     = _Backspace_Key;
variable Key_Enter  = "\r";
variable KP_Enter   = "^M";
variable Key_Space  = " ";
variable Key_Tab    = "\t";

%   looks strange? it is but fingers off!
%------------------------------
variable Key_Escape   = "^[]]";
%------------------------------
%   SLang does not allow a single escape to be associated to a
%   function. But you have learnt - and so God intended - that a
%   brief press of escape is all it takes to stop some operations.
%   Well, here comes the fix.
%
%   When a single escape is detected, keymap.c turns it nilly
%   willy into a character sequence, namely the string used here to
%   define Key_Escape. At that moment, SLang is happy to assign a
%   function to it and you are happy because you are just pressing
%   Escape to trigger that function. Are we together?

%   the strings for the function keys
variable Key_F1     = "^[[[A";
variable Key_F2     = "^[[[B";
variable Key_F3     = "^[[[C";
variable Key_F4     = "^[[[D";
variable Key_F5     = "^[[[E";
variable Key_F6     = "^[[17~";
variable Key_F7     = "^[[18~";
variable Key_F8     = "^[[19~";
variable Key_F9     = "^[[20~";
variable Key_F10    = "^[[21~";
variable Key_F11    = "^[[23~";
variable Key_F12    = "^[[24~";

variable Key_F13    = "^[[25~";
variable Key_F14    = "^[[26~";
variable Key_F15    = "^[[28~";
variable Key_F16    = "^[[29~";
variable Key_F17    = "^[[31~";
variable Key_F18    = "^[[32~";
variable Key_F19    = "^[[33~";
variable Key_F20    = "^[[34~";

variable Key_Up     = "^[[A";
variable Key_Down   = "^[[B";
variable Key_Right  = "^[[C";
variable Key_Left   = "^[[D";

variable Key_Home   = "^[[1~";
variable Key_Ins    = "^[[2~";
variable Key_Del    = "^[[3~";
variable Key_End    = "^[[4~";
variable Key_PgUp   = "^[[5~";
variable Key_PgDn   = "^[[6~";

variable greykeys = String_Type [35,2];
greykeys [*,*] =
[
 [Key_F1    ,   "F1"       ],
 [Key_F2    ,   "F2"       ],
 [Key_F3    ,   "F3"       ],
 [Key_F4    ,   "F4"       ],
 [Key_F5    ,   "F5"       ],
 [Key_F6    ,   "F6"       ],
 [Key_F7    ,   "F7"       ],
 [Key_F8    ,   "F8"       ],
 [Key_F9    ,   "F9"       ],
 [Key_F10   ,   "F10"      ],
 [Key_F11   ,   "F11"      ],
 [Key_F12   ,   "F12"      ],
 [Key_F13   ,   "F13"      ],
 [Key_F14   ,   "F14"      ],
 [Key_F15   ,   "F15"      ],
 [Key_F16   ,   "F16"      ],
 [Key_F17   ,   "F17"      ],
 [Key_F18   ,   "F18"      ],
 [Key_F19   ,   "F19"      ],
 [Key_F20   ,   "F20"      ],
 [Key_Up    ,   "Up"       ],
 [Key_Down  ,   "Down"     ],
 [Key_Right ,   "Right"    ],
 [Key_Left  ,   "Left"     ],
 [Key_Home  ,   "Home"     ],
 [Key_Ins   ,   "Insert"   ],
 [Key_Del   ,   "Delete"   ],
 [Key_End   ,   "End"      ],
 [Key_PgUp  ,   "PgUp"     ],
 [Key_PgDn  ,   "PgDn"     ],
 [Key_BS    ,   "Backspace"],
 [Key_Enter ,   "Enter"    ],
 [Key_Space ,   "Space"    ],
 [Key_Tab   ,   "Tab"      ],
 [Key_Escape,   "Escape"   ],
];

%   round, angle, square, curly brackets

variable roundL  = '\050';
variable roundR  = '\051';
variable angleL  = '\074';
variable angleR  = '\076';
variable squareL = '\133';
variable squareR = '\135';
variable curlyL  = '\173';
variable curlyR  = '\175';

variable r_reminder = "No: cancel rectangle first.";
variable s_reminder = "No: cancel selection first.";

%*********************************************************
%   Jed Directories
%*********************************************************

%   Jed_Home_Directory specifies the user's directory
%   where personal jed-related files are to be found.
%   Normally, this corresponds to the user's home directory
%   unless the user has specified an alternate directory
%   via the JED_HOME environment variable.

Jed_Home_Directory = getenv ("JED_HOME");
if (Jed_Home_Directory == NULL)
    Jed_Home_Directory = getenv ("HOME");

variable RecentFiles = Jed_Home_Directory + "/recently_edited.txt";
variable RecentDirs = Jed_Home_Directory + "/recently_accessed.txt";

%*********************************************************
%   functions to handle directories/files
%*********************************************************

define parse_filename (fn)
%----------------------------------------------------------
%   Usage:
%   (dir, file) = parse_filename (fn)
%
%   This function breaks a file specification into dir and
%   filename. For example, /a/b/c returns /a/b/ (dir) and
%   c (file).
%----------------------------------------------------------
{
   return (path_dirname (fn), path_basename (fn));
}

define dircat (dir, file)
%----------------------------------------------------------
%   Usage:
%   String_Type dircat (String_Type D, String_Type F)
%
%   This function provides the clean pathname of file F
%   in directory D.
%----------------------------------------------------------
{
    if (dir == NULL)  dir  = Null_String;
    if (file == NULL) file = Null_String;

    if(strlen (dir))
    {
        if (dir[-1] != '/') dir += slash;
    }

    expand_filename (dir + file);
}

define buffer_filename ()
%---------------------------------------------------------
%   Usage:
%   string buffer_filename ()
%
%   Returns the full path name of the file associated
%   with the current buffer. If none is associated with it,
%   the empty string is returned.
%----------------------------------------------------------
{
    variable
        args = __pop_args (_NARGS),
        file,
        dir;

    (file, dir, , ) = getbuf_info(__push_args (args));
    ifnot (strlen (file)) dir =  Null_String;
    return dir + file;
}

define check_buffer_filename (fullpfile)
%---------------------------------------------------------
%   Needs full path as string parameter.
%   Returns 1 if any buffer is associated with it,
%   or else 0.
%   Used to avoid different buffers for same disk file.
%----------------------------------------------------------
{
    variable ffile, ddir;

    (ddir, ffile) = parse_filename (fullpfile);

    ifnot (bufferp(ffile)) return 0;

    variable tmpbf=whatbuf (), r=0;

    sw2buf(ffile);
    if (fullpfile==buffer_filename ()) r = 1;
    sw2buf(tmpbf);

    return r;
    %   if 1, a buffer is already associated to the file
}

define search_path_for_file (path, file)
%----------------------------------------------------------
%   Usage:
%   string search_path_for_file (string P, string F)
%
%   The search_path_for_file function searches the
%   directories specified by the comma separated set of
%   directories P for the filename F. If the
%   file exists, it returns the expanded filename, otherwise
%   it returns NUL
%----------------------------------------------------------
{
    variable dir;
    foreach (strtok (path, ","))
    {
        dir = ();
        file = dircat (dir, file);

        if (file_status (file) == 1) return file;
    }
    return NULL;
}

define expand_jedlib_file (f)
%----------------------------------------------------------
%   Search for file f in jed library directory and return
%   expanded pathname if found or the Null string otherwise.
%----------------------------------------------------------
{
   f = search_path_for_file (get_slang_load_path (), f);
   if (f == NULL) return Null_String;
   return f;
}

define find_jedlib_file (file)
%----------------------------------------------------------
%   Find a file from JED_LIBRARY,
%   returns number of lines read, 0 if not found.
%----------------------------------------------------------
{
    file = expand_jedlib_file (file);
    ifnot (strlen (file)) return 0;
    return find_file (file);
}

define stopkey ()
{
    variable ret=0;

    %   character 23    ctrl-w
    %   character 27    escape (intended as single escape)
    %   character 28    abort character (ctrl-backslash)
    %                   but this one will usually not be caught

    ret =
    LAST_CHAR == 23 or LASTKEY[0] == 27 or LAST_CHAR == 28;
    %   don't use LAST_CHAR for escape because our single escape
    %   is not just one character

    return ret;
}

define read__mini (prompt, dflt, inistr, m_history)
{
    mS = m_history;
    %   minibuffer history
    %   0   search strings
    %   1   file names
    %   2   motley mix

    variable rply = Null_String;

    tt_send ("\033[?1c");

    if(mS==1)
        rply = read_with_completion (prompt, dflt, inistr, 'f');
    else
        rply = read_mini (prompt, dflt, inistr);
        %   from misc.c

    if (stopkey)
        rply = Null_String;

    return rply;
}

define read_path_from_mini (p)
%----------------------------------------------------------
%   usage
%   string read_path_from_mini (string p)
%
%   Prompts for a file name using the parameter as a prompt.
%   Returns the filename read from the minibuffer. It can
%   also been used to return a directory.
%----------------------------------------------------------
{
    variable
        thisfile = Null_String,
        thisdir = Null_String;

    (thisfile,thisdir,,) = getbuf_info ();

    thisfile = thisdir + thisfile;

    return read__mini (p, "//", thisfile, 1);
    %   don't use empty string as default, bug chase
}

define rename_buffer (name)
%----------------------------------------------------------
%   Rename current buffer to the string argument
%----------------------------------------------------------
{
    variable flags = getbuf_info ();
    pop ();
    setbuf_info (name, flags);
}

define patch_cmdline_file (file)
%----------------------------------------------------------
%   Removes superfluous slashes in a file name
%----------------------------------------------------------
{
   variable ch = file[0];
   file = strcompress (file, slash);
   if (ch == '/') file = strcat (slash, file);
   return file;
}

%*********************************************************
%   functions to set/unset/check flags
%*********************************************************

define _test_buffer_flag (x)
%----------------------------------------------------------
%   if flag x set:  returns 1
%   else            returns 0
%
%   values for hex integer x are defined in getbuf_info
%----------------------------------------------------------
{
    variable flags;

    (,,,flags) = getbuf_info ();
    return flags & x;
}

define _set_buffer_flag (x)
%----------------------------------------------------------
%   values for hex integer x are defined in getbuf_info
%----------------------------------------------------------
{
    getbuf_info ();
    () | x;
    setbuf_info (());
    %    parameter is hexadecimal, e.g. 0x10 for overwrite mode
}

define _unset_buffer_flag (x)
%----------------------------------------------------------
%   values for hex integer x are defined in getbuf_info
%----------------------------------------------------------
{
    getbuf_info ();
    () & ~x;
    setbuf_info (());
}

define _set_or_unset_buffer_flag ()
%----------------------------------------------------------
%   usage: _set_or_unset_buffer_flag (set, flag)
%   argument set is 1 for setting, 0 for unsetting
%   values for hex integer flag are defined in getbuf_info
%----------------------------------------------------------
{
    exch ();
    %  (set,flag) ==> (flag,set)

    if (()) _set_buffer_flag (());
    else _unset_buffer_flag (());
}

define _toggle_buffer_flag (f)
%----------------------------------------------------------
%   values for hex integer f are defined in getbuf_info
%----------------------------------------------------------
{
    setbuf_info (getbuf_info () xor f);
}

define set_buffer_modified_flag ()
%----------------------------------------------------------
%   If argument what is 1, consider buffer modified.
%   If argument what is 0, consider buffer unchanged.
%----------------------------------------------------------
{
    _set_or_unset_buffer_flag ((), 0x1);
}

define buffer_modified ()
%----------------------------------------------------------
%   Usage:
%   Int_Type buffer_modified ()
%
%   returns non-zero if the buffer modified flag
%   is set. It returns zero if the buffer modified flag
%   is not been set. This works on the current buffer.
%----------------------------------------------------------
{
   _test_buffer_flag (0x01);
}

define set_buffer_undo ()
%----------------------------------------------------------
% set undo mode for buffer.
% If argument is 1, undo is on.  0 turns it off
%----------------------------------------------------------
{
   _set_or_unset_buffer_flag ((), 0x20);
}

define set_readonly ()
%----------------------------------------------------------
%   Usage:
%   void set_readonly (int what)
%
%   0   turn readonly off
%   1   turn readonly on
%----------------------------------------------------------
{
   _set_or_unset_buffer_flag ((), 0x08);
}

define is_readonly ()
%----------------------------------------------------------
%   This function returns a non-zero value if the buffer
%   is read-only; otherwise it returns 0.
%----------------------------------------------------------
{
   _test_buffer_flag (0x08);
}

define is_overwrite_mode ()
%----------------------------------------------------------
%   usage
%   Int_Type is_overwrite_mode ()
%
%   This function returns a non-zero value
%   if the buffer is in overwrite-mode;
%   otherwise it returns 0.
%----------------------------------------------------------
{
    _test_buffer_flag (0x10);
}

define set_overwrite ()
%----------------------------------------------------------
%   set_overwrite (Int_Type x)
%   If the parameter is non-zero, the buffer will be
%   put in overwrite mode; otherwise it will be put in insert
%   mode.
%----------------------------------------------------------
{
   _set_or_unset_buffer_flag ((), 0x10);
}

define toggle_crmode ()
%----------------------------------------------------------
%   Toggles end-of-line mark between DOS/UNIX
%   DOS  mark is CRLF
%   UNIX mark is LF
%----------------------------------------------------------
{
    if (is_readonly) return;

   _toggle_buffer_flag (0x400);
   set_buffer_modified_flag (1);
}

define toggle_readonly ()
%----------------------------------------------------------
%   This function toggles the read-only status of the current
%   buffer.
%----------------------------------------------------------
{
   _toggle_buffer_flag (0x08);
}

define toggle_overwrite ()
%----------------------------------------------------------
%   Pressing the Insert key will toggle between inserting
%   text and overwriting text when typing.
%
%   The current mode is normally indicated in the staus bar.
%   However, the toggle can also be used in the minibuffer
%   and this is not reflected in the stutus bar.
%----------------------------------------------------------
{
   _toggle_buffer_flag (0x10);
}

define toggle_undo ()
%----------------------------------------------------------
%   This function toggles the undo mode of the current buffer.
%----------------------------------------------------------
{
   _toggle_buffer_flag (0x20);
}

define set_wrap_column ()
%----------------------------------------------------------
%   The WRAP variable is local. You can have different
%   wrap columns in two buffers. You can also have different
%   wrap mode in different buffers.
%----------------------------------------------------------
{
    if (is_readonly)
    {
        flush("No: buffer is read-only.");
        return;
    }

    current_mini_cmd = _function_name;
    variable tmpw = Null_String;

    tmpw =
    strtrim(read__mini ("Wrap at column:", Null_String, string(WRAP), 2));

    if(stopkey) return;

    if(strlen(tmpw) != 2)
    {
        flush("Bad input: wrap column is still " + string(WRAP));
        return;
    }

    try
    {
        WRAP = integer (tmpw);
    }

    catch AnyError:
    {
        flush("Bad input: wrap column is still " + string(WRAP));
        return;
    }

    if(WRAP < 30)
    {
        flush("No, too low: wrap column set to 30.");
        return;
    }

    if(WRAP > 78)
    {
        WRAP = 78;
        flush("No, too high: wrap column set to 78.");
        return;
    }

    flush("Wrap column set to " + string(WRAP));
}

define toggle_wrap ()
%----------------------------------------------------------
%   If wrap mode is on, stop it. If wrap mode is off,
%   start it.
%
%   When wrap mode is on, text typed by the user will wrap
%   around at the column determined by the WRAP variable,
%   which is 70 by default in the C source and can also be
%   set in the startup file. With wrap mode off, the line
%   can extend as long as resources permit.
%----------------------------------------------------------
{
    if (is_readonly)
    {
        flush("No: buffer is read-only.");
        return;
    }

    variable
        modf = 0,
        modn = Null_String;

    (modn, modf) = what_mode ();

    %   if wrap on, switch it off
    if (modn=="w" and modf==1)
    {
        set_mode ("-", 0);
        %   never use Null_String as mode string, heavy trouble

        flush("Wrap is off.");
        return;
    }

    %   switch wrap on
    set_mode ("w", 1);
    flush("Wrap is on at column " + string(WRAP));
}

define set_buffer_no_backup ()
%----------------------------------------------------------
%   No backup when saving this buffer
%----------------------------------------------------------
{
   _set_buffer_flag (0x100);
}

define set_buffer_no_autosave ()
%----------------------------------------------------------
%   No autosave for this buffer
%----------------------------------------------------------
{
   _unset_buffer_flag (0x02);
}

%*********************************************************
%   positioning, inserting, deleting
%*********************************************************

define end_of_trail ()
%----------------------------------------------------------
%   Cursor to the end of line incl. trailing whitespace
%----------------------------------------------------------
{
    eol ();
}

define go_left ()
%----------------------------------------------------------
%   Go left one, return nothing
%----------------------------------------------------------
{
    () = left ();
}

define go_right ()
%----------------------------------------------------------
%   Go right one, return nothing
%----------------------------------------------------------
{
    () = right ();
}

define go_up ()
%----------------------------------------------------------
%   Go up one, return nothing
%----------------------------------------------------------
{
    () = up ();
}

define go_down ()
%----------------------------------------------------------
%   Go down one, return nothing
%----------------------------------------------------------
{
    () = down ();
}

define newline ()
%----------------------------------------------------------
%   Inserts a new line disregarding indentation, cursor is
%   positioned on first column.
%----------------------------------------------------------
{
    insert_char ('\n');
}

define del_to_bol ()
%----------------------------------------------------------
%   Will delete from left of cursor to begin of line
%----------------------------------------------------------
{
    if (markp) return;
    push_mark ();
    bol ();
    if (markp) del_region ();
}

define del_to_eol ()
%----------------------------------------------------------
%   Will delete from cursor (incl.) to end of line
%----------------------------------------------------------
{
    if (eobp) return;
    if (markp) return;
    push_mark ();
    eol ();
    if (markp) del_region ();
}

define del_line ()
%----------------------------------------------------------
%   Delete the current line including the terminating
%   newline code. It will look like the following line
%   moves up to the cursor, except at end of buffer.
%----------------------------------------------------------
{
    if (what_block) return;
    bol();
    delete_line ();
}

define close_buffer ()
%----------------------------------------------------------
%   Close current buffer whether modified or not,
%   no questions asked.
%
%   The scratch buffer is not closed, it is erased.
%   If empty, exit option will be offered.
%----------------------------------------------------------
{
    variable tmpbf = whatbuf();

    set_buffer_modified_flag (0);
    assoc_delete_key (bkm, whatbuf);
    delbuf(tmpbf);

    if(tmpbf != "*scratch*") return;

    %   *scratch* from here

    if(bobp == eobp and not buffer_modified)
    {
        %   other buffers still open?
        %   if not show exit option

        variable
            bfcount  = buffer_list (),
            tmpcount = bfcount;

        loop(tmpcount)
        {
            tmpbf = ();
            if (is_substr(tmpbf,slash))
            {
                bfcount--;
                continue;
            }

            if (tmpbf[0] == ' ') bfcount--;
        }

        if(bfcount > 1) return;

        variable rply = Null_String;
        rply = strlow(read__mini("Exit Editor (y/n)?", "y", "y", 2));
        if (rply == "y") exit_jed ();
    }
}

define vertical_trim ()
%----------------------------------------------------------
%   This reduces in the entire buffer consecutive lines
%   containing only whitespace to just one empty line.
%----------------------------------------------------------
{
    variable done=0;

    bob();
    forever
    {
        %   whiteline? if not, go down and loop
        ifnot(is_whiteline)
        {
            if(down(1)) continue;
            else break;
        }

        %   got a whiteline, we keep it
        %   but we delete all following whitelines, if any
        ifnot(down(1)) break;

        forever
        {
            %   eob immediately after whiteline?
            if(eobp) break;

            if(is_whiteline)
            {
                delete_line();
                done=1;
            }
            else break;
        }

        %   got a non-empty line, continue
        if(down(1)) continue;
        else break;
    }
    bob();
    if(done) flush ("Buffer trimmed vertically.");
    else     flush ("Buffer already trimmed.");
}

define trim_lines ()
%----------------------------------------------------------
%   trailing spaces are trimmed line by line in selection
%   empty lines are not deleted
%----------------------------------------------------------
{
    variable
        lnc = 0,
        lnz = markp();

    EXIT_BLOCK pop_spot();
    push_spot();

    ifnot(lnz)
    {
        call("eol_cmd");
        %   does the trimming on its own

        flush("No selection to trim, current line trimmed.");
        return;
    }

    ifnot(check_region (0))
    {
        %   rectangle
        flush(r_reminder);
        return;
    }

    pop_mark (1);
    lnc = lnz + what_line ();

    while (what_line < lnc)
    {
        call("eol_cmd");
        %   does the trimming on its own

        ifnot(down(1)) break;
    }

    flush("All lines in selection trimmed.");
}

define goto_top_of_window ()
%----------------------------------------------------------
%   Positions cursor at top of window
%----------------------------------------------------------
{
    go_up (window_line () - 1);
}

define goto_bottom_of_window ()
%----------------------------------------------------------
%   Positions cursor at bottom of window.
%----------------------------------------------------------
{
    go_down (window_info ('r') - window_line ());
}

% ("scroll_down", "+", a_kmap);
% ("scroll_up",   "-", a_kmap);

define scroll_up ()
%------------------------------------------------
%   If cursor is not in the middle of window, this
%   function will center the current line. If current
%   line is already centered, the effect is scroll up
%   in place.
%
%   Assuming there are enough lines, the cursor
%   keeps its location while the text seems to be
%   rolling up.
%------------------------------------------------
{
    if(check_rectangle) return;

    variable lm = window_info ('r') / 2;
    variable cc = what_column ();

    if (window_line > lm)
    {
        %   cursor not mid-window, move current line there
        recenter (lm);

        goto_column(cc);
        return;
    }

    %   cursor is already mid-window, scroll up
    if (down (1)) recenter (lm);
    goto_column(cc);
}

define scroll_down ()
%------------------------------------------------
%   If cursor is not in the middle of window, this
%   function will center the current line. If current
%   line is already centered, the effect is scroll
%   down in place.
%
%   Assuming there are enough lines, the cursor
%   keeps its location while the text seems to be
%   rolling down.
%------------------------------------------------
{
    if(check_rectangle) return;

    variable lm = window_info ('r') / 2;
    variable cc = what_column ();

    if (window_line < lm)
    {
        %   cursor not mid-window, move current line there
        recenter (lm);

        goto_column(cc);
        return;
    }

    %   cursor is already mid-window, scroll up
    if (up (1)) recenter (lm);
    goto_column(cc);
}

define spaces_for_tabs ()
%----------------------------------------------------------
%   Will insert spaces up to the next tab stop,
%   deternined by the variable TAB counting from 1.
%----------------------------------------------------------
{
    if (TAB < 1) TAB=4;

    variable n = what_column ();
    %   variable n is used for multiple purposes

    n = (1 + (n - 1)/TAB)*TAB - (n - 1);
    %   number of spaces up to next tab stops
    %   tab stops are defined by TAB starting at 1

    loop(n) insert_char(' ');
}

define backtab ()
%----------------------------------------------------------
%   Moves to the closest tab stop left, nothing is deleted
%----------------------------------------------------------
{
    variable n,m;

    if(TAB < 1) TAB=4;

    n = what_column ();
    m = (n-1) mod TAB;
    if (m<=0) m += TAB;

    %   tab stops are defined by TAB starting at 1

    if (n > TAB) go_left(m);
}

define skip_grey()
%----------------------------------------------------------
%   Skip whitespace and control chars
%----------------------------------------------------------
{
    skip_chars(GreyChars);
}

define skip_black()
%----------------------------------------------------------
%   Skip characters which are not grey (white, control)
%----------------------------------------------------------
{
    skip_chars(BlackChars);
}

define bskip_grey()
%----------------------------------------------------------
%   Backskip whitespace and control chars
%----------------------------------------------------------
{
    bskip_chars(GreyChars);
}

define bskip_black()
%----------------------------------------------------------
%   Backskip characters which are not grey (white, control)
%----------------------------------------------------------
{
    bskip_chars(BlackChars);
}

define wordset ()
%----------------------------------------------------------
%   Defines tokens and delimiters for a word
%----------------------------------------------------------
{
    variable i;
    for(i=0;i<33;i++) GreyChars += char(i);
    GreyChars += char(127);
    BlackChars = "^" + GreyChars;

    % test "!-~ - ";

    %   this word definition includes everything
    %   except control chars, space, backspace (127)
    %define_word (WordSet);
}

define begin_of_word_left ()
%----------------------------------------------------------
%   to begin of current word, if cursor on word (past begin)
%   or to begin of word left otherwise
%----------------------------------------------------------
{
    if(check_rectangle) return;

    variable p = _get_point ();

    bskip_black ();

    if (p != _get_point()) return;
    %   if cursor was on word or adjacent right
    %   it has moved to begin and we are finished

    %   cursor has not moved, so it was between words
    %   backskip delimiters

    bskip_grey ();
    bskip_black ();
}

define begin_of_word_right ()
%----------------------------------------------------------
%   to begin of next word
%----------------------------------------------------------
{
    if(check_rectangle) return;

    variable p = _get_point();

    skip_grey ();

    if (p != _get_point()) return;
    %   if cursor was between words,
    %   it has moved to begin of next word, finished

    %   cursor was not between words,
    %   so skip tokens then delimiters
    skip_black ();
    skip_grey ();
}

define select_word ()
%----------------------------------------------------------
%   If cursor on a word, select the word
%   otherwise jump to next word and select it
%----------------------------------------------------------
{
    %   do nothing if there is a selection
    if (markp) return;

    skip_grey();
    begin_of_word_right ();
    begin_of_word_left ();

    push_mark();
    %   no highlight

    skip_black ();
}

define duplicate_floor_char ()
%----------------------------------------------------------
%   duplicates at current position the character below it
%----------------------------------------------------------
{
    if (is_readonly) return;
    if (markp) return;

    push_spot ();
    %   save cursor position

    variable p = what_column ();

    ifnot (down (1))
    {
        pop_spot ();
        return;
    }
    %   cursor on bottom line, nothing to duplicate

    if (goto_column_best_try (p) != p)
    {
        pop_spot ();
        return;
    }
    %   cursor moved but not to same column
    %   target line is shorter, no char to duplicate

    if (eolp ())
    {
        pop_spot ();
        return;
    }
    %   cursor at end of line, nothing to duplicate

    %   if control here, normal case

    variable ch = what_char ();
    %   get the character to duplicate

    pop_spot ();
    %   go back to original position

    insert_char (ch);
    %   duplicate character from target line
    %   will work even in overwrite mode
}

define duplicate_ceiling_char ()
%----------------------------------------------------------
%   duplicates at current position the character above it
%----------------------------------------------------------
{
    if (is_readonly) return;
    if (markp) return;

    push_spot ();
    %   save cursor position

    variable p = what_column ();

    if (up(1) < 1)
    {
        pop_spot ();
        return;
    }
    %   cursor was on top line, could not move up,
    %   nothing to duplicate

    if (goto_column_best_try (p) != p)
    {
        pop_spot ();
        return;
    }
    %   cursor moved but not in same column
    %   target line is shorter, no char to duplicate

    if (eolp ())
    {
        pop_spot ();
        return;
    }
    %   cursor is at end of line, nothing to duplicate

    %   if control here, normal case

    variable ch = what_char ();
    %   get the character to duplicate

    pop_spot ();
    %   go back to original position

    insert_char (ch);
    %   duplicate character from target line
    %   will work even in overwrite mode
}

define duplicate_line ()
%----------------------------------------------------------
%   Inserts a duplicate of current line below it,
%   cursor stays put
%----------------------------------------------------------
{
    if (is_readonly) return;
    if (markp) return;

    push_spot ();
    bol ();
    push_mark ();
    eol ();
    bufsubstr ();

    newline ();
    insert(());
    pop_spot ();
}

%*********************************************************
%   strings
%*********************************************************

#ifnexists list_to_array
define list_to_array ()
{
    variable list, type;
    if (_NARGS == 2)
        (list, type) = ();
    else
    {
        list = ();
        type = typeof(list[0]);
    }
    variable n = length(list);
    variable a = type[n];
    _for (0, n-1, 1)
    {
        variable i = ();
        a[i] = list[i];
    }
    return a;
}
#endif

define vinsert ()
%----------------------------------------------------------
%   Usage:
%   void vinsert (string, fmt,...);
%
%   This function will insert string formatted like in Sprintf
%   with a variable number of arguments.
%----------------------------------------------------------
{
    _NARGS-1;
    Sprintf;
    insert;
}

define line_as_string ()
%----------------------------------------------------------
%   Usage:
%   string line_as_string ()
%
%   This function returns the current line as a string.
%   This does not include the newline character at the end
%   of the line. The editing point is left at the end of
%   the line, that is, function does not preserve the point.
%----------------------------------------------------------
{
    bol ();
    push_mark ();
    eol ();
    bufsubstr ();
}

define str_split (sstr, n)
%----------------------------------------------------------
%   splits a string into two substrings, returns both
%   string and split position given by parameters
%----------------------------------------------------------
{
    variable sub1, sub2;
    sub1 = substr (sstr, 1, n - 1);
    sub2 = substr (sstr, n, -1);
    return (sub1, sub2);
    % so call it (sub1, sub2) = str_split(sstr, n);
}

%*********************************************************
%   sundry functions
%*********************************************************

define slim_quit ()
{
    %   just in case
    set_buffer_modified_flag (0);
    set_readonly (0);

    %   special buffers with slim keymap
    if (is_substr(whatbuf,slash)) delbuf(whatbuf);
}

define reset_slim_keymap ()
%----------------------------------------------------------
%   slim_kmap is defined in keymap.c
%   and used repeatedly for different purposes
%   reset before re-using
%----------------------------------------------------------
{
    variable i;
    $1 = "slim_kmap";

    undefinekey (Key_F1, $1);
    undefinekey (Key_F10, $1);
    undefinekey (Key_Enter, $1);

    for (i=0; i < 32; i++)
        undefinekey (char(i), $1);

    %   text entry in minibuffer
    for (i=32; i< 127; i++)
        definekey ("self_insert_cmd", char(i), $1);

    for (i=160; i < 256; i++)
        definekey ("self_insert_cmd", char(i), $1);

    definekey ("newline_and_indent",    Key_Enter,  $1);
    definekey ("next_char_cmd",         Key_Right,  $1);
    definekey ("previous_char_cmd",     Key_Left,   $1);
    definekey ("previous_line_cmd",     Key_Up,     $1);
    definekey ("next_line_cmd",         Key_Down,   $1);
    definekey ("bol",                   Key_Home,   $1);
    definekey ("eol",                   Key_End,    $1);
    definekey ("delete_char_cmd",       Key_Del,    $1);
    definekey ("backward_delete_char",  Key_BS,     $1);
    definekey ("write_buffer",          "^S",       $1);
    definekey ("slim_quit",             "^W",       $1);
    definekey ("slim_quit",             Key_Escape, $1);
}

define what_block ()
%----------------------------------------------------------
%   determine what kind of block, char/column/line block
%----------------------------------------------------------
{
    return block_type ();

    %   0   default
    %           character stream    if shiftkey pressed
    %           no block            otherwise
    %   1   column
    %   2   line
}

define chk_stream()
%----------------------------------------------------------
%   returns -1  if there is no selection
%   returns  0  if a rectangle is selected
%   returns number of lines if a char block is selected
%----------------------------------------------------------
{
    variable l1, l2, lines=0;

    ifnot(markp) return -1;
    %   there is no selection

    if(what_block==1) return 0;
    %   a rectangle is selected

    l1 = what_line();
    call ("exchange");
    l2 = what_line();
    call ("exchange");

    lines = l1-l2;
    if(lines < 0) lines = -lines;
    lines++;

    return lines;
    %   a char block is selected
}

define is_posixwhite ()
%----------------------------------------------------------
%   Will check the character at cursor, returning:
%      0   is not posix white
%      1   is posix white
%----------------------------------------------------------
{
    variable tmp = 0;
    tmp = what_column ();
    push_spot();

    skip_chars ("^\s"R);
    tmp = (what_column () == tmp);
    %   1 if cursor moved
    %   0 if cursor moved not

    pop_spot();
    return tmp;
}

define is_lilywhite ()
%----------------------------------------------------------
%   Will check the character at cursor, returning:
%      0   non-white
%      1   white leading
%      2   white between
%      3   white trail
%----------------------------------------------------------
{
    variable
        tst     =  0,
        black   =  0,
        leading =  1,
        between =  2,
        trail   =  3;

    tst = looking_at(" ") or looking_at("\t") or eolp();

    ifnot (tst) return black;

    %   it is white, leading?
    push_spot();
    bskip_chars (" \t");
    tst = bolp ();
    pop_spot();
    if (tst) return leading;

    %   it is white, trailing?
    push_spot();
    skip_chars (" \t");
    tst = eolp ();
    pop_spot();
    if (tst) return trail;

    %   it is white, not leading, not trailing
    return between;
}

define is_whiteline ()
%----------------------------------------------------------
%   return 1    line has only whitespace
%   return 0    otherwise
%----------------------------------------------------------
{
     push_spot ();
     bol ();
     skip_chars(" \t");
     variable r = eolp ();
     pop_spot ();
     return r;

    %    don't change, it's going to break plenty
}

define no_mode ()
%----------------------------------------------------------
%   This defines the default no_mode
%----------------------------------------------------------
{
    set_mode ("-", 0);
    %   do not set mode to Null_String, trouble

    use_syntax_table (Null_String);
    use_keymap ("global");
    %   syntax highlight requested in C code
}

define require ()
%----------------------------------------------------------
%   Just a better name for evalfile but void, no return.
%   Call with strings as arguments.
%   First argument is a file in jed's library directory
%   otherwise it must have full path.
%   Second argument is the namespace. If absent, Global
%   namespace will be used.
%   example: require("madmode");
%   madmode.sl would have to be in the library directory
%----------------------------------------------------------
{
    if (_NARGS == 0) return;

    variable
        ffile = Null_String,
        nnamespace = Null_String;

    variable args = __pop_args (_NARGS);
    %   this is an array, array elements are structures,
    %   these structures have only one field called 'value',
    %   this field is a string

    if (_NARGS == 1)
    {
        ffile = args [0].value;
        %   default namespace is "Global"
        () = evalfile (ffile);
        return;
    }

    if (_NARGS == 2)
    {
        ffile = args [0].value;
        nnamespace = args [1].value;
        () = evalfile (ffile,nnamespace);
    }
}

define set_sue_palette ()
%----------------------------------------------------------
%   set color defaults
%----------------------------------------------------------
{
    %   reset palette
    tt_send ("\033]R");

    variable sc = Null_String;

    sc = strcat(JED_ROOT,"/lib/colors/",_Default_Color_Scheme);

    require(sc);
}

define sue_defaults ()
%----------------------------------------------------------
%   Restores sue's defaults - namely:
%
%   colors          sue
%   mode            no_mode
%
%----------------------------------------------------------
{
    no_mode ();
    set_sue_palette ();
    update (1);
    flush("To reset keymap, exit and restart.");
}

define write_scratch (ssttrr)
%----------------------------------------------------------
%   Write to scratch, returns to current position
%   Useful when debugging to avoid minibuffer messages
%----------------------------------------------------------
{
    variable from_bf = whatbuf ();
    sw2buf ("*scratch*");
    toggle_block (0);
    eob();
    newline ();
    newline ();
    insert (ssttrr);
    if(bufferp(from_bf)) sw2buf (from_bf);
    else sw2buf (string(_time), ".new");
    rename_buffer (from_bf);
}

define set_color ()
%----------------------------------------------------------
%
%
%----------------------------------------------------------
{
    _set_color ();
}

define dummy_menu (ttitle)
%----------------------------------------------------------
%   uses the menu bar like a heading
%----------------------------------------------------------
{
    variable n = slash + string(_time) + slash;
    menu_create_menu_bar (n);
    menu_use_menu_bar (n);
    menu_delete_items (n);
    menu_append_popup (n, ttitle);
}

define keyname(ks,modf)
%----------------------------------------------------------
%   converts key string ks to usual key name
%----------------------------------------------------------
{
    variable
        i = 0,
        kstring = Null_String,
        sl = strlen(ks),
        L = length(greykeys[*,0]);

    if(sl==1)
    {
        if(ks[0]==127) return "Backspace";
        if(ks[0]==0  ) return "Space";
        if(ks[0]==27 ) return "Escape";
        if(ks[0]==28 ) return "Control_backslash";
        if(ks[0]==29 ) return "Control_bracketright";
        if(ks[0]==30 ) return "Control_asciicircum";
        if(ks[0]==31 ) return "Control_underscore";
    }

    else if(ks[0]==27 and sl==2)
        return char(ks[1]);

    else if(ks[0]==27)
    {
        if (modf==8) ks = strcat("^" + substr(ks,2,-1));
        else ks = strcat("^[" + substr(ks,2,-1));
    }

    %   problem with enter and tab
    else if(ks[0] < 32 and strlen(ks)==1)
    {
        if (ks[0]==9 or ks[0]==13)
            return "Ctrl "+char(64+ks[0]);
        else return char(64+ks[0]);
    }

    else if(ks[0] > 31 and strlen(ks) == 1) return ks;

    for (i=0; i < L; i++)
    {
         ifnot (strcmp(greykeys[i,0],ks)) break;
    }

    if (i<L) kstring=greykeys[i,1];

    return kstring;
}

define readable_keys ()
%----------------------------------------------------------
%   This functions replaces the strings from dump_bindings
%   with readable names for the functions and grey keys,
%   replacements are padded with spaces to ensure same length
%----------------------------------------------------------
{
    %   do not touch the spaces in the strings below!
    %   they give the replacements the same length
    %   as the original strings from dump_bindings

    bob ();
    while (fsearch("self_insert_cmd"))
        delete_line ();

    bob ();
    replace     ("ESC [ A",     "Up     ");

    bob ();
    replace     ("ESC [ B",     "Down   ");

    bob ();
    replace     ("ESC [ C",     "Right  ");

    bob ();
    replace     ("ESC [ D",     "Left   ");

    bob ();
    replace     ("ESC [ 2 ~",   "Insert   ");

    bob ();
    replace     ("ESC [ 3 ~",   "Delete   ");

    bob ();
    replace     ("ESC [ 4 ~",   "End      ");

    bob ();
    replace     ("ESC [ 1 ~",   "Home     ");

    bob ();
    replace     ("ESC [ 5 ~",   "PgUp     ");

    bob ();
    replace     ("ESC [ 6 ~",   "PgDn     ");

    bob ();
    replace     ("ESC [ [ A",   "F1       ");

    bob ();
    replace     ("ESC [ [ B",   "F2       ");

    bob ();
    replace     ("ESC [ [ C",   "F3       ");

    bob ();
    replace     ("ESC [ [ D",   "F4       ");

    bob ();
    replace     ("ESC [ [ E",   "F5       ");

    bob ();
    replace     ("ESC [ 1 7 ~", "F6         ");

    bob ();
    replace     ("ESC [ 1 8 ~", "F7         ");

    bob ();
    replace     ("ESC [ 1 9 ~", "F8         ");

    bob ();
    replace     ("ESC [ 2 0 ~", "F9         ");

    bob ();
    replace     ("ESC [ 2 1 ~", "F10        ");

    bob ();
    replace     ("ESC [ 2 3 ~", "F11        ");

    bob ();
    replace     ("ESC [ 2 4 ~", "F12        ");

    bob ();
    replace     ("ESC ] ]", "Escape ");

    bob ();
    CASE_SEARCH = 1;
    replace     ("SPACE", "Space");

    bob ();
    replace     ("^@    ", "^Space");

    bob ();
    replace     ("^M   ", "Enter");

    bob ();
    replace     ("ESC   ", "Escape");

    bob ();
    replace     ("^\\        ", "^Backslash");

    bob ();
    replace     ("^]           ", "^Bracketright");

    bob ();
    replace     ("^^          ", "^Asciicircum");

    bob ();
    replace     ("TAB", "Tab");

    %   F13 to F20

    bob();
    while(fsearch("ESC [ 2 5 ~")) delete_line();

    bob();
    while(fsearch("ESC [ 2 6 ~")) delete_line();

    bob();
    while(fsearch("ESC [ 2 8 ~")) delete_line();

    bob();
    while(fsearch("ESC [ 2 9 ~")) delete_line();

    bob();
    while(fsearch("ESC [ 3 1 ~")) delete_line();

    bob();
    while(fsearch("ESC [ 3 2 ~")) delete_line();

    bob();
    while(fsearch("ESC [ 3 3 ~")) delete_line();

    bob();
    while(fsearch("ESC [ 3 4 ~")) delete_line();
}

define reset_screen ()
%----------------------------------------------------------
%   This function clears screen garbage brought in by
%   interfering applications not under the editor's control,
%   e.g. commands issued to the shell. After which,
%   it redraws the editor's screen.
%
%   It is more than the 'redraw' function in that it makes
%   an attempt to eliminate not only internal display
%   disturbances but also interference from other
%   applications. It may fail.
%----------------------------------------------------------
{
    () = fflush (stderr);
    clearerr (stderr);
    () = fflush (stdout);
    clearerr (stdout);
    call("redraw");
    sue_defaults ();
}

define insert_code_for_key ()
%----------------------------------------------------------
%   Will insert at the cursor the code corresponding to
%   the key pressed.
%
%   For letters and digits, this means nothing special.
%   For command keys, this means that they will not be
%   executed, their code will be inserted. For example,
%   pressing the left arrow will give ^[[D.
%
%   A similar function is called 'quoted_insert' in the
%   source and in jed documents and postings.
%----------------------------------------------------------
{
    if (is_readonly) return;

    IGNORE_USER_ABORT = 1;

    flush("Next key will be inserted as a code...");

    variable c=0;
    flush_input ();
    forever
    {
        c = getkey ();
        ifnot (c) insert("^@");
        else insert (char (c));

        ifnot (input_pending(1)) break;
    }
    update (1);

    IGNORE_USER_ABORT = 0;

    %call ("quoted_insert");
    %   After activating quoted_insert
    %   the code of a grey key will be inserted,
    %   e.g. pressing F1 will insert ^[[[A
    %   or pressing Tab will insert a real tab.
    %   For self-inserting characters it's business as usual.
    %   However, alt-key combos fail in sue (but not in jed)
    %   for unknown reasons but surely related to the way
    %   sue tells global and alt keymap apart.
}

define strcmpi (a, b)
%----------------------------------------------------------
%   compares strings like strcmp, case-insensitive
%----------------------------------------------------------
{
  return strcmp (strup(a), strup(b));
}

define disk_new_file ()
%----------------------------------------------------------
%   A new buffer is being opened. The random name offered
%   at the prompt can be changed. When the name is agreed,
%   press Enter and the new buffer will be opened.
%
%   The name for the new buffer will be refused, if it
%   happens to be the name of a buffer already open.
%----------------------------------------------------------
{
    current_mini_cmd = _function_name;

    variable
        fn      = Null_String,
        thisdir = Null_String;

    (,thisdir,,) = getbuf_info ();

    mS=1;
    %   files and paths history

    forever
    {
        fn = strcat (thisdir, string(_time), ".new");

        %   a name is generated seeded from current time
        %   but user can confirm or change it
        %   name is only accepted if no file with same name exists
        %   program will loop until unique and valid name is entered

        fn = read__mini ("Name new file:", Null_String, fn, 1);

        ifnot(strlen(fn)) return;

        if (file_status (fn) == 2) return;
        %   use to escape query, just wipe out prompt

        if (file_status (fn) == 0) break;
        %   name is ok, proceed

        message ("Already in use, try a different name.");
    }

    () = find_file (fn);
    %   new buffer is opened
}

define disk_save_permission (ffile)
%----------------------------------------------------------
%   Will check if a file is writable by current user
%   returning 1 for yes, 0 for no
%----------------------------------------------------------
{
    if (ffile==Null_String) return 0;

    variable chk, st, perms;

    st = stat_file (ffile);

    if(NULL==st) return 1;
    %   we don't know why, just go ahead and try

    %   convert mode to octal
    perms = sprintf("%o",st.st_mode);

    %   get current user permissions
    perms = substr(perms,4,1);
    chk = integer(perms);
    return (chk==2 or chk==3 or chk==6 or chk==7);
}

define disk_save_as ()
%----------------------------------------------------------
%   current buffer is saved prompting for a file name
%----------------------------------------------------------
{
    current_mini_cmd = _function_name;

    variable f_name  = Null_String;

    f_name = read_path_from_mini ("Save as:");

    ifnot(strlen(f_name)) return;

    %   check file status before proceeding

    if (check_buffer_filename(f_name))
    {
        variable refusl =
        "File is already associated to a buffer, choose different name.";
        flush (refusl);
        return;
    }

    variable l_written = 0;
    variable f_status = file_status (f_name);

    if (f_status == 2);

    else if (f_status == -1)
        error ("File exists and is not accessible");

    else if (f_status == -2)
        error ("Invalid path");

    else if (f_status == -3)
        error ("Undetermined error");

    else if (f_status == 0)
    {
        toggle_block (0);
        l_written = write_buffer (f_name);
        if(l_written) flush("Saved as new file.");
    }

    else if (f_status == 1)
    {
        ifnot(disk_save_permission (f_name))
        {
            flush("No permission to write to file: " + f_name);
            return;
        }

        if (1 == get_y_or_n ("File exists: overwrite"))
        {
            toggle_block (0);
            l_written = write_buffer (f_name);
            if(l_written)
                flush("Saved on existing file.");
        }
    }
}

define disk_save_buffer ()
%----------------------------------------------------------
%   Will save the current buffer to disk if the buffer
%   has been modified. If a file with same name exists
%   on disk, it will be overwritten without warning.
%
%   However, it can happen that some other program was
%   working on that file and made changes to it. In
%   such a case, the user will be warned that the file
%   has changed on disk and asked to confirm before
%   overwriting.
%----------------------------------------------------------
{
    variable file = buffer_filename ();

    ifnot(strlen (file))
    {
        disk_save_as ();
        return;
    }

    ifnot(buffer_modified) return;

    variable tmpblk = what_block ();

    if(tmpblk==1)
    {
        %   write_region_internal fails on rectangles
        %   and then saving fails (file.c).
        %   Cancel rectangle here, restore when finished

        ()=check_rectangle();
        toggle_block(1);
    }

    ifnot(disk_save_permission (file))
    {
        flush("No permission to write to file: " + file);
        return;
    }

    () = write_buffer (file);

    %   saving while line block present
    %   turns the highlight into a stream
    %   in that case, restore the lines
    if (tmpblk==2) stream_to_lines ();
    else if (tmpblk==1) restore_rectangle();
}

define disk_save_preserve_mtime ()
%----------------------------------------------------------
%   Works like disk_save_buffer but the file saved to disk
%   will keep timestamp (modification time) of previous
%   file.
%----------------------------------------------------------
{
    ifnot(buffer_modified) return;

    variable tmpblk = what_block ();

    if(tmpblk==1)
    {
        %   write_region_internal fails on rectangles
        %   and then saving fails (file.c).
        %   Cancel rectangle here, restore when finished

        ()=check_rectangle();
        toggle_block(1);
    }

    variable file = buffer_filename ();

    ifnot(strlen (file))
    {
        disk_save_as ();
        return;
    }

    ifnot(disk_save_permission (file))
    {
        flush("No permission to write to file: " + file);
        return;
    }

    %   preliminary operations to preserve time stamp
    {
        variable st = stat_file (file);
        if (st == NULL)
        {
            %   should not happen
            disk_save_as();
            return;
        }

        %   1st Jan 1970, 00:00:00 UTC, start of Unix epoch
        %   st.st_mtime, number of seconds since then
        %   converted to date string by ctime
        variable strf = ctime(st.st_mtime);

        %   strf needs quotation marks because it includes spaces
        strf = strcat("\"", strf, "\"");
    }

    () = write_buffer (file);
    () = run_shell_cmd("touch --date=" + strf + " " + file);

    %   saving while line block present
    %   turns the highlight into a stream
    %   in that case, restore the lines
    if (tmpblk==2) stream_to_lines ();
    else if (tmpblk==1) restore_rectangle();
}

define find_matching_fence ()
%----------------------------------------------------------
%   If cursor on any of the following characters
%
%       () [] {}
%
%   it will jump to its match (assuming it is there),
%   otherwise it will stay put.
%
%   False positives are possible if unpaired fences are found
%   in comments or pre-processor directives.
%
%   Function is not dependent on any syntax definition.
%----------------------------------------------------------
{
    variable
        i  = 0,
        L  = 6,
        ch = what_char(),
        A  = Int_Type [8],
        B  = Int_Type [8],
        move,
        currenT = 0,
        wanteD  = 0,
        directioN = 0;

    %   following definitions should run just once
    %   outside this function but burden tolerable

    A[0] = roundL;  B[0] = roundR;
    A[1] = roundR;  B[1] = roundL;
    A[2] = squareL; B[2] = squareR;
    A[3] = squareR; B[3] = squareL;
    A[4] = curlyL;  B[4] = curlyR;
    A[5] = curlyR;  B[5] = curlyL;

    %   to include angle brackets (for html)
    %   uncomment the following lines
    %A[6] = angleL;  B[6] = angleR;
    %A[7] = angleR;  B[7] = angleL;
    %L = 8;

    for (i=0; i < L; i++)
    {
        if (ch == A[i])
        {
            currenT = A[i];
            wanteD  = B[i];
            directioN = wanteD - currenT;
            break;
        }
    }

    ifnot (directioN)
    {
        flush("Cursor must be on a fence.");
        return 0;
    }
    %   char not a fence

    variable
        tallY = 1,
        c_col = what_column (),
        c_ln  = what_line ();

    if (directioN > 0) move = &right;
    else move = &left;

    while (@move(1))
    {
        if (what_char == currenT)
            tallY++;
        else if(what_char == wanteD)
            tallY--;

        ifnot(tallY) return 1;
    }

    goto_line (c_ln);
    goto_column (c_col);
    return 0;
}

define ed_permissions (o_string)
%----------------------------------------------------------
%
%----------------------------------------------------------
{
    %   o-string is the octal digit string
    %   defining permissions

    variable i, o, perms_letters=Null_String;

    for (i=4;i<7;i++)
    {
        o = substr (o_string,i,1);

        switch (o)
            {
                case "0":
                perms_letters += "---";
            }
            {
                case "1":
                perms_letters += "--x";
            }
            {
                case "2":
                perms_letters += "-w-";
            }
            {
                case "3":
                perms_letters += "-wx";
            }
            {
                case "4":
                perms_letters += "r--";
            }
            {
                case "5":
                perms_letters += "r-x";
            }
            {
                case "6":
                perms_letters += "rw-";
            }
            {
                case "7":
                perms_letters += "rwx";
            }
    }
    return perms_letters;
}

define switch_buffer (previous)
{
    %   if argument positive,
    %   switch to previous buffer else to next

    variable
        n,
        buf;

    n = buffer_list ();
    %   buffer names are on the stack
    %   n is positive

    if (previous > 0) _stk_reverse (n-1);
    loop (n)
    {
        buf = ();
        n--;
        if (buf[0] == ' ') continue;
        sw2buf (buf);
        _pop_n (n);
        return;
    }
}

define quit_sue ()
{
    sw2buf("*scratch*");

    forever
    {
        %   switch to previous buffer, it will cycle around
        switch_buffer(1);
        set_buffer_modified_flag (0);

        if (whatbuf == "*scratch*") break;
    }

    tt_send ("\033[?0c");
    % default cursor

    exit_jed ();
}

define exit_sue ()
{
    tt_send ("\033[?0c");
    % default cursor

    exit_jed ();
}

define execute_cmd ()
%----------------------------------------------------------
%   Execute a command, i.e. a function from an sl-file
%   known to the interpreter. The command must be
%   correctly typed in the minibuffer and dispatched with
%   the Enter key.
%
%   A file that is not one of sue's components can be made
%   known to the interpreter with the command require,
%   e.g. require("stuff") assuming the file stuff.sl is in
%   the library directory.
%
%   If the file you are requiring is not in the library
%   directory, type the full path as in:
%   require("/opt/test.sl");
%----------------------------------------------------------
{
    current_mini_cmd = _function_name;
    call("evaluate_cmd");
}

%**********************************************************
%   hooks
%**********************************************************

define menu_kstring()
%----------------------------------------------------------
%   to be called exclusively from menu_hlp
%----------------------------------------------------------
{
    variable kstring = ();
    %   best_keystring pushed into the stack from menu.c

    variable k_describe = ( );
    %   this is string mmddff from menu.c

    if(k_describe==NULL) k_describe = Null_String;
    if(kstring==NULL)    kstring    = Null_String;

    if(kstring==Null_String)
    {
        %   <ctrl><space> is char(0) and cannot be identified.
        %   also sometimes a missing assignment
        %   just means the shortcut is overloaded

        variable nada = "none";
        push_spot();

        if(bol_bsearch("Cancel Selection"))
            nada = "Escape";
        else if(bol_bsearch("Other Window"))
            nada = "Ctrl Space";
        else if(bol_bsearch("Indent"))
            nada = "Tab";
        else if(bol_bsearch("Unindent"))
            nada = "Shift Tab";
        else if(bol_bsearch("Previous Sibling"))
            nada = "Shift Tab";

        pop_spot();
        insert (nada);
        return;
    }

    %   kstring is not empty

    variable
        i = 0,
        kl = strlen(kstring);

    if(k_describe=="ShiftCtrl " and kl==1)
        k_describe = "Shift ";

    if(kl==1) for(i=0;i<128;i++)
    {
        if (kstring==char(0))
        {
            k_describe += "Space";
            insert(k_describe);
            return;
        }

        if (kstring==char(9))
        {
            k_describe += "Tab";
            insert(k_describe);
            return;
        }

        if (kstring==char(13))
        {
            k_describe += "Enter";
            insert(k_describe);
            return;
        }

        if (kstring==char(32))
        {
            k_describe += "Space";
            insert(k_describe);
            return;
        }

        if (kstring==char(127))
        {
            k_describe += "Backpace";
            insert(k_describe);
            return;
        }

        if (char(i) == kstring)
        {
            if (i<32)
                k_describe += "^"+char(i+64);

            else
                k_describe += strup(char(i));

            insert(k_describe);
            return;
        }
    }

    if(i==128)
    {
        insert ("none");
        return;
    }

    if(kl > 1)
    {
        %   string may not start with ESC
        %   something like ^k + left
        %   currently not used

        variable
            n     = is_substr (kstring, "^["),
            kstr2 = kstring;

        if (n > 1)
        {
            kstring = substr (kstr2, n, -1);
            kstr2   = substr (kstr2, 1, n-1);
        }

        variable L=length(greykeys[*,0]);

        for (i=0; i < L; i++)
        {
            ifnot (strcmp(greykeys[i,0],kstring)) break;
        }
        if (i<L) kstring=greykeys[i,1];

        if (n > 1)
            kstring = kstr2 + " " + kstring ;
    }

    k_describe += kstring;

    %   one and only one keybinding from keymap.c
    %   with a duplicate in the scripts
    if(kstring=="^KE")
        k_describe = "Alt F4";

    insert(k_describe);
}

define menu_hlp ()
%----------------------------------------------------------
%   DON'T TOUCH!
%   This function is called from menu.c to display help
%   for menu items when pressing F1 on a menu entry.
%----------------------------------------------------------
{
    %   get the goodies from stack

    variable mdf0      = ();
    variable bestkstr0 = ();
    %   these two are not needed right mow
    %   we push them again into the stack here below

    variable helpkey0 = ();
    variable tmpnm0   = ();

    variable helpkey = strtrim (helpkey0 + " [#]");
    variable tmpnm   = strtrim (tmpnm0 + " [#]");

    %   prepare the help buffer
    delbuf(" /MenuHelp/");
    sw2buf(" /MenuHelp/");

    %   insert help file
    if (1 > insert_file(strcat (JED_ROOT,"/lib/sue.hlp")))
    {
        flush("Help file not found!");
        delbuf(" /MenuHelp/");
        return;
    }
    bob();

    %   search for proxy keyword first, real search follows
    ifnot (bol_fsearch(tmpnm))
    {
        flush("Not found: " + tmpnm0);
        delbuf(" /MenuHelp/");
        return;
    }

    %   search for the real keyword now
    ifnot (bol_fsearch(helpkey))
        flush ("Not found: " + helpkey0);

    else
    {
        %   search key found

        go_up(1);
        bol();
        push_mark();
        bob();
        del_region();

        %   text above keyword deleted
        %   search for delimiter downstream

        () = bol_fsearch(helpkey);
        () = ffind ("[#]");
        del_to_eol();

        ifnot (bol_fsearch("[#]"))
        {
            flush ("Delimiter not found.");
            %   unlikely to happen
            return;
        }

        %   delimiter found, delete text below it
        bol();
        push_mark();
        eob();
        del_region();

        %   display help text at line 2
        () = bol_bsearch(helpkey0);
        recenter(2);
        eol();

        %   we insert now a description of the keybinding
        %   for the menu entry, if any.

        goto_column(40);
        insert ("current keybinding: ");

        %   push back into stack the two variables
        %   received from menu.c as a string for the modifier
        %   and best_keystring
        mdf0;
        bestkstr0;

        menu_kstring();

        set_status_line("  Press any key to exit", 0);
        set_readonly(1);

        %   update and wait
        update(1);
        flush_input(getkey());
        flush(" ");
    }
}

define lngth(A)
{
    if(A==NULL) return 0;
    return length(A);
}

define list_chkdir (S)
{
    %   dirs are returned as they were passed on
    %   everything else returns a Null_String

    variable stf;

    stf = lstat_file (S);

    if (stf==NULL)
        return Null_String;

    ifnot(stat_is("dir",stf.st_mode))
        return Null_String;

    return S;
}

define listsubs (whichdir)
%------------------------------------------------
%   returns array with all subdirs in whichdir,
%   whichdir must terminate with a slash
%------------------------------------------------
{
    integer("1");
    variable L = 0;
    if(whichdir != Null_String) L = strlen(whichdir);
    ifnot(L) return NULL;

    if(whichdir[L-1] != '/')
        whichdir = strcat(whichdir, "/");

    variable
        A = String_Type[1024],
        B = String_Type[1024];

    A = listdir (whichdir);

    if(A==NULL) return NULL;
    ifnot(length(A)) return NULL;

    B = array_map (String_Type, &list_chkdir, whichdir + A);
    A = A[where(B!=Null_String)];
    A = A[array_sort (A, "strcmpi")];

    %   subdirs are sorted in array A, relative path

    return A;
}

define nwinz ()
{
    variable
        is_split = nwindows() - MINIBUFFER_ACTIVE - 1;

    %   mostly following message needed
    if(is_split)
        flush("Feature only available full screen.");

    return is_split;
}

define trimsave ()
{
    variable
        prmpt = "Trim all lines in this buffer when saving (y/n)?",
        rply  = Null_String;

    rply = strlow(read__mini(prmpt, "y", "y", 2));

    if (rply != "n")
    {
        rply = "Lines in this buffer will be trimmed when saving.";
        TRIMSAVE=1;
    }

    else
    {
        rply = "No trimming when saving this buffer.";
        TRIMSAVE=0;
    }

    flush(rply);
}

define bfss ()
{
    %   quick bufsubstr() variant
    %   rather than go to eol

    if(markp) pop_mark(0);
    push_mark();

    () = goto_column_best_try(64 + what_column);
    %   this will not pass eol, will limit string to 64 chars

    return bufsubstr();
    %   mark is popped
}

define re_looking_at (re)
{
    push_spot ();

    push_mark ();
    eol ();
    %go_right (1);
    %  make sure newline is included

    1 == string_match (bufsubstr (), re, 1);
    %  on stack

    pop_spot ();
}

define del_tmpbuf ()
%----------------------------------------------------------
%   delete buffers whose name begins with "tmp"
%   but not the current buffer
%----------------------------------------------------------
{
    variable bf = Null_String;

    loop (buffer_list)
    {
        bf = ();
        if(is_substr(bf, "tmp") == 1) delbuf(bf);
    }
}

define block_cancel();

define toggle_windows ()
%----------------------------------------------------------
%   if screen is split, unsplit it,
%   otherwise split, keeping cursor on same line
%   and copying current buffer into tmp buffer
%   for the other split window.
%----------------------------------------------------------
{
    variable is_split = 0;
    is_split = nwindows() - MINIBUFFER_ACTIVE - 1;
    if(is_split)
    {
        onewindow ();
        del_tmpbuf();
        return;
    }

    block_cancel();

    variable ln    = what_line ();
    variable tmpbf = whatbuf();
    variable fn    = strcat ("tmp", string(_time), slash);
    delbuf(fn);
    pop2buf(fn);

    insbuf (tmpbf);
    set_buffer_modified_flag (0);
    set_buffer_hook ("update_hook", &shape_cursor1);
    goto_line (ln);

    otherwindow ();
    goto_line (ln);
}

define nada()
{
    % ideosyncracy slang 2.2.4
}

define make_backup_filename (dir, file)
%----------------------------------------------------------
%   returns backup filename
%   DON'T TOUCH, this function is run as a hook from file.c
%----------------------------------------------------------
{
    if (dir == "/tmp/") return "";
    strcat (dir, file, "~");
}

define make_autosave_filename (dir, file)
%----------------------------------------------------------
%   returns autosave filename
%   DON'T TOUCH, this function is run as a hook from file.c
%----------------------------------------------------------
{
     sprintf ("%s#%s#", dir, file);
}

define runhooks ()
%----------------------------------------------------------
%   void runhooks (string hook, [optional args...])
%----------------------------------------------------------
{
   variable args = __pop_args (_NARGS - 1);
   variable hook = ();
   hook = __get_reference (hook);
   if (hook != NULL) @hook (__push_args (args));
}

define jed_startup_hook ()
%----------------------------------------------------------
%   This function gets executed right before JED
%   enters its main editing loop. For last minute
%   modifications of data structures that did not exist
%   when startup files were loaded.
%----------------------------------------------------------
{
    variable scratch = "*scratch*";

    % turn on Abort character processing
    IGNORE_USER_ABORT = 0;

    TAB = TAB_DEFAULT;

    ifnot (strcmp(whatbuf (), scratch) or buffer_modified ())
    {
        setbuf (scratch);
        erase_buffer ();
        set_buffer_modified_flag (0);
    }

    while (_stkdepth) pop();
    %   empty string on stack, reason unknown!
}
add_to_hook ("_jed_startup_hooks", &jed_startup_hook);

define command_line_hook ()
%----------------------------------------------------------
%   Function called from main.c to process the command line.
%   The general form of the command line is:
%
%       sue [-a other_rc_file] [-viewer] [file ...]
%
%   Options must come first and in the order stated.
%
%   Arguments:
%
%   [-a other_rc_file]          resource file other than default
%   [-viewer]                   readonly/no shell
%
%   [file ...]                  one or more files to be edited
%                               files will be opened if they exist
%                               or created if not [not in the viewer]
%                               wild cards can be used
%
%----------------------------------------------------------
{
    %   very essential, very sensitive function
    %   changes need plenty of time for debugging

    %   The global variable __argc gives the number of
    %   command line arguments. The arguments are in the
    %   array __argv numbered from 0 to __argc - 1.

    variable
        n =0,
        nf=0,
        i =0,
        j =0,
        file=Null_String,
        depth,
        init_file;

    init_file = dircat (Jed_Home_Directory, "sue.rc");

    if (1 != file_status (init_file))
        init_file = NULL;

    set_sue_palette();

    if (__argc==1);
    %   nothing to do

    %   malformed input: "-a" and nothing follows
    else if (__argc==2 and __argv[1] == "-a") return;

    %   malformed input: "-a -viewer"
    else if (__argc > 2)
    {
        if (__argv[1] == "-a" and __argv[2] == "-viewer")
            return;
    }

    %   avoiding malformed arguments implies that you may
    %   have to load files called "-a" or "-viewer" from
    %   the file manager rather than from the command line

    n = __argc;

    %  skip __argv[0], i.e. editor's name
    --n;
    i = 1;

    if (n) file = __argv[i];
    else file = Null_String;

    %   alternative init_file must be first argument
    if (n)
    {
        if (file == "-a")
        {
            i++;
            n--;
            init_file = __argv[i];

            i++;
            n--;

            if (1 != file_status (init_file))
            {
                flush (strcat ("Init File does not exist: ", init_file));
                sleep (1);
                return;
                %   editor will start with defaults
                %   will not start as viewer
            }
        }

        else if (file == "-viewer")
        {
            i++;
            n--;
            viewer_only=1;
        }
    }

    if (init_file != NULL)
    {
        depth = _stkdepth ();

        if (file_status (init_file) == 1)
            require(init_file);

        depth = _stkdepth () - depth;

        if (depth)
        {
            flush ("Excess junk left on stack by " + init_file);
            sleep (1);
            _pop_n (depth);
        }
    }

    while (n > 0)
    {
        file = __argv[i];

        --n;
        ++i;

        j = file_status (file);
        if (j < 0 or j > 1) continue;

        else if (viewer_only and file_status (file) == 1)
            break;

        else if(viewer_only);

        else
        {
            () = find_file(patch_cmdline_file (file));
            ++nf;
        }
    }

    if (nf and viewer_only==0)
        flush ("Total files opened or new: " + string(nf));
}

define shape_cursor1 ()
%----------------------------------------------------------
%   Shape cursor for read-only, overwrite, insert
%----------------------------------------------------------
{
    %tt_send("\033[41m");

    if (is_readonly) tt_send ("\033[?1c");
    %   invisible cursor

    else if (is_overwrite_mode) tt_send ("\033[?6c");
    %   huge block cursor

    else
    {
        if(eolp) tt_send ("\033[?4c");
        else     tt_send ("\033[?2c");
    }
    %   normal insert mode in edit buffer
    %   blinking underscore, bigger at eol
}

define shape_cursor0 ()
%----------------------------------------------------------
%   Shape cursor when changing buffer
%----------------------------------------------------------
{
    if(nwindows>1) return;
    if (MINIBUFFER_ACTIVE) tt_send ("\033[?1c");
    set_buffer_hook ("update_hook", &shape_cursor1);
}
add_to_hook ("_jed_switch_active_buffer_hooks", &shape_cursor0);


define cursor_after_exit ()
{
    tt_send ("\033[?0c");
    %   restore default cursor
}
%add_to_hook ("_jed_exit_hooks", &cursor_after_exit);
%add_to_hook ("_jed_quit_hooks", &cursor_after_exit);



%*********************************************************
%  Initialize minibuffer, load file manager
%*********************************************************

mini_keymap ();
wordset();

putenv("MAN_KEEP_FORMATTING=0");
%   Will avoid control codes in text only manpages.
%   May or may not work but in any event
%   manpages are going to be cleaned up.

require("sue");
require("suemenu");
require("dls");
require("basics");

variable i=0, j=0, l=0, n=__argc;
for (i=1; i < n; i++)
{
    viewer_only=0;
    if(__argv[i]=="-viewer")
    {
        viewer_only=1;
        break;
    }
}

if (viewer_only)
{
    for(j=i+1; j < n; j++)
    {
        %   only one file to load

        if(file_status (__argv[j]) == 1)
        {
            l = find_file ( patch_cmdline_file (__argv[j]));
            break;
        }
    }

    if(eobp)
    {
        flush("File is empty.");
        sleep(3);
        exit_jed();
    }

    viewer_load ();
    if(l!=1)
    {
        set_sue_palette();
        update(1);
        flush("File to load (from command line) missing or invalid.");
        sleep(3);
        exit_jed();
    }
}

else
{
    suemenu ();
    set_status_line (" %O  %p  %F  |  F1=Help", 1);
}
